'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var React = require('react');

function _interopNamespace(e) {
    if (e && e.__esModule) return e;
    var n = Object.create(null);
    if (e) {
        Object.keys(e).forEach(function (k) {
            if (k !== 'default') {
                var d = Object.getOwnPropertyDescriptor(e, k);
                Object.defineProperty(n, k, d.get ? d : {
                    enumerable: true,
                    get: function () { return e[k]; }
                });
            }
        });
    }
    n["default"] = e;
    return Object.freeze(n);
}

var React__namespace = /*#__PURE__*/_interopNamespace(React);

/******************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */

var __assign = function() {
    __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};

/** @deprecated */
function __spreadArrays() {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
}

var ALPHABET = [
    "A",
    "B",
    "C",
    "D",
    "E",
    "F",
    "G",
    "H",
    "I",
    "J",
    "K",
    "L",
    "M",
    "N",
    "O",
    "P",
    "Q",
    "R",
    "S",
    "T",
    "U",
    "V",
    "W",
    "X",
    "Y",
    "Z",
];
var NUMBERS = ["1", "2", "3", "4", "5", "6", "7", "8", "9"];

var lengthRange = [4, 5, 6, 7, 8];
function useOfflineCaptcha(ref, UserOpt) {
    var _a = React__namespace.useState(), captcha = _a[0], setCaptcha = _a[1];
    React__namespace.useEffect(function () {
        if (!ref.current)
            return;
        var _a = UserOpt.type, type = _a === void 0 ? "mixed" : _a, _b = UserOpt.length, length = _b === void 0 ? 5 : _b, _c = UserOpt.sensitive, sensitive = _c === void 0 ? false : _c, _d = UserOpt.width, width = _d === void 0 ? 200 : _d, _e = UserOpt.height, height = _e === void 0 ? 50 : _e, _f = UserOpt.fontColor, fontColor = _f === void 0 ? "#000" : _f, _g = UserOpt.background, background = _g === void 0 ? "rgba(255, 255, 255, .2)" : _g;
        if (!lengthRange.includes(length)) {
            length = 5;
        }
        var element = ref.current;
        var candidates = [];
        var answer = "";
        switch (type) {
            case "numeric":
                candidates = __spreadArrays(NUMBERS);
                break;
            case "mixed":
                candidates = __spreadArrays(ALPHABET, NUMBERS);
                break;
            case "alpha":
            default:
                candidates = __spreadArrays(ALPHABET);
                break;
        }
        function getRandomNumber(min, max) {
            return Math.floor(Math.random() * (max - min + 1) + min);
        }
        function gen() {
            var prevCaptcha = document.getElementById("offline-captcha-canvas-area");
            if (prevCaptcha) {
                element.removeChild(prevCaptcha);
            }
            var canvas = document.createElement("canvas");
            canvas.width = width;
            canvas.height = height;
            canvas.setAttribute("id", "offline-captcha-canvas-area");
            canvas.setAttribute("style", "border: 1px solid black; background: " + background);
            element.appendChild(canvas);
            var ctx = canvas.getContext("2d");
            function drawLine(color) {
                ctx.beginPath();
                ctx.moveTo(0, 10 + Math.random() * canvas.height);
                ctx.lineTo(canvas.width, 10 + Math.random() * canvas.height);
                ctx.lineWidth = Math.random() * 1 + 1;
                ctx.closePath();
                ctx.strokeStyle = color;
                ctx.stroke();
            }
            function shuffleCandidates(arr) {
                var _a;
                for (var i = arr.length - 1; i > 0; i--) {
                    var j = Math.floor(Math.random() * (i + 1));
                    _a = [arr[j], arr[i]], arr[i] = _a[0], arr[j] = _a[1];
                }
                return arr.slice(0, length);
            }
            function drawText(string) {
                var textFonts = ["Arial", "Georgia", "Helvetica", "Impact"];
                for (var i = 0; i < string.length; i++) {
                    var space = width / string.length;
                    var initial = 5;
                    ctx.font = "2em " + textFonts[getRandomNumber(0, textFonts.length - 1)];
                    ctx.fillStyle = fontColor;
                    ctx.fillText(string[i], initial + i * space, getRandomNumber(30, canvas.height - 10), 200);
                }
            }
            answer = shuffleCandidates(candidates).join("");
            drawText(answer);
            ["darkgray", "red", "darkblue"].forEach(function (color) { return drawLine(color); });
        }
        function validate(string) {
            var regex = new RegExp(answer, "" + (sensitive ? "g" : "gi"));
            if (regex.test(string))
                return true;
            return false;
        }
        setCaptcha({ gen: gen, validate: validate });
    }, []);
    return __assign({}, captcha);
}

exports["default"] = useOfflineCaptcha;
//# sourceMappingURL=index.js.map
